// coding: utf-8
/** Created by: Udo Schmal | https://www.gocher.me/ */
(function () {
  function getOpacity(el, def) {
    var result;
    var style=document.defaultView.getComputedStyle(el, null);
    if ('opacity' in style) {
      result = style.opacity;
    }
    result = parseInt(result);
    if (!isNaN(result)) result = def;
    return result;
  }

  function setOpacity(el, val) {
    el.style.opacity = val;
  }

  function fadeIn(el) {
    var opacity = getOpacity(el, 0);
    var last = new Date();
    var tick = function() {
      opacity += (new Date() - last) / 400;
      setOpacity(el, (opacity>1 ? 1 : opacity));
      last = new Date();
      if (opacity < 1) { window.requestAnimationFrame(tick); }
    };
    tick();
  }

  function fadeOut(el) {
    var opacity = getOpacity(el, 1);
    var last = new Date();
    var tick = function() {
      opacity -= (new Date() - last) / 400;
      setOpacity(el, (opacity<0 ? 0 : opacity));
      last = new Date();
      if (opacity > 0) { window.requestAnimationFrame(tick); }
    };
    tick();
  }
  var el = document.getElementById('el'),
  wrapper = document.getElementById('wrapper');
  wrapper.style.position = 'relative';
  wrapper.style.height = '105px';
  wrapper.style.width = '100%';
  el.style.display = 'block';
  el.style.backgroundColor = 'silver';
  el.style.border = '1px solid red';
  el.style.width = '100px';
  el.style.height = '100px';
  var btnFadeIn = document.getElementById('fadeIn');
  if (btnFadeIn) {
    btnFadeIn.addEventListener('click', function () {
      fadeIn(el);
    });
  }
  var btnFadeOut = document.getElementById('fadeOut');
  if (btnFadeOut) {
    btnFadeOut.addEventListener('click', function () {
      fadeOut(el);
    });
  }
})();
